#include "cps.h"

/*============================
Rockman 2 - The Power Fighters
============================*/

static struct BurnInputInfo DrvInputList[] =
{
	{"P1 Coin"       , BIT_DIGITAL, CpsInp020 + 4, "p1 coin"   },
	{"P1 Start"      , BIT_DIGITAL, CpsInp020 + 0, "p1 start"  },
	{"P1 Up"         , BIT_DIGITAL, CpsInp001 + 3, "p1 up"     },
	{"P1 Down"       , BIT_DIGITAL, CpsInp001 + 2, "p1 down"   },
	{"P1 Left"       , BIT_DIGITAL, CpsInp001 + 1, "p1 left"   },
	{"P1 Right"      , BIT_DIGITAL, CpsInp001 + 0, "p1 right"  },
	{"P1 Attack"     , BIT_DIGITAL, CpsInp001 + 4, "p1 fire 1" },
	{"P1 Jump"       , BIT_DIGITAL, CpsInp001 + 5, "p1 fire 2" },
	{"P1 Select"     , BIT_DIGITAL, CpsInp001 + 6, "p1 fire 3" },

	{"P2 Coin"       , BIT_DIGITAL, CpsInp020 + 5, "p2 coin"   },
	{"P2 Start"      , BIT_DIGITAL, CpsInp020 + 1, "p2 start"  },
	{"P2 Up"         , BIT_DIGITAL, CpsInp000 + 3, "p2 up"     },
	{"P2 Down"       , BIT_DIGITAL, CpsInp000 + 2, "p2 down"   },
	{"P2 Left"       , BIT_DIGITAL, CpsInp000 + 1, "p2 left"   },
	{"P2 Right"      , BIT_DIGITAL, CpsInp000 + 0, "p2 right"  },
	{"P2 Attack"     , BIT_DIGITAL, CpsInp000 + 4, "p2 fire 1" },
	{"P2 Jump"       , BIT_DIGITAL, CpsInp000 + 5, "p2 fire 2" },
	{"P2 Select"     , BIT_DIGITAL, CpsInp000 + 6, "p2 fire 3" },

	{"Reset"         , BIT_DIGITAL, &CpsReset    , "reset"     },
	{"Diagnostic"    , BIT_DIGITAL, CpsInp021 + 1, "diag"      },
	{"Service"       , BIT_DIGITAL, CpsInp021 + 2, "service"   },
};

STDINPUTINFO(Drv);

/*=================
 Megaman 2 (USA)
=================*/


static struct BurnRomInfo Megaman2RomDesc[]=
{
	{"rm2ux.03"  , 0x080000, 0x93e28bde, 0x10},
	{"rm2ux.04"  , 0x080000, 0x74ebf83c, 0x10},

	{"rm2u.03"   , 0x080000, 0x8ffc2cd1, 0x10},
	{"rm2u.04"   , 0x080000, 0xbb30083a, 0x10},
	{"rm2.05"    , 0x080000, 0x02ee9efc, 0x10},

	{"rm2.14"    , 0x200000, 0x9b1f00b4,    1},
	{"rm2.16"    , 0x200000, 0xc2bb0c24,    1},
	{"rm2.18"    , 0x200000, 0x12257251,    1},
	{"rm2.20"    , 0x200000, 0xf9b6e786,    1},

	{"rm2.01a"   , 0x020000, 0xd18e7859,    2},
	{"rm2.02"    , 0x020000, 0xc463ece0,    2},

	{"rm2.11"    , 0x200000, 0x2106174d,    2},
	{"rm2.12"    , 0x200000, 0x546c1636,    2},
};

STD_ROM_PICK(Megaman2) STD_ROM_FN(Megaman2)

struct BurnDriver BurnDrvCpsMegaman2=
{
	{"megaman2", "Mega Man 2: The Power Fighters (US 960708)", NULL, "Capcom", "CPS2", "1996", NULL, NULL},
	BDF_GAME_WORKING, 2, HARDWARE_CAPCOM_CPS2,
	NULL, Megaman2RomInfo, Megaman2RomName, DrvInputInfo, NULL,
	Cps2Init, CpsExit, Cps2Frame, CpsRedraw, CpsAreaScan,
	&CpsRecalcPal ,384, 224, 4, 3
};

/*=================
 Megaman 2 (Asia)
=================*/


static struct BurnRomInfo Megamn2aRomDesc[]=
{
//	{"rm2ax.03"  , 0x080000, 0x00000000, 0x10},
//	{"rm2ax.04"  , 0x080000, 0x00000000, 0x10},

	{"rm2a.03"   , 0x080000, 0x2b330ca7, 0x10},
	{"rm2a.04"   , 0x080000, 0x8b47942b, 0x10},
	{"rm2.05"    , 0x080000, 0x02ee9efc, 0x10},

	{"rm2.14"    , 0x200000, 0x9b1f00b4,    1},
	{"rm2.16"    , 0x200000, 0xc2bb0c24,    1},
	{"rm2.18"    , 0x200000, 0x12257251,    1},
	{"rm2.20"    , 0x200000, 0xf9b6e786,    1},

	{"rm2.01a"   , 0x020000, 0xd18e7859,    2},
	{"rm2.02"    , 0x020000, 0xc463ece0,    2},

	{"rm2.11"    , 0x200000, 0x2106174d,    2},
	{"rm2.12"    , 0x200000, 0x546c1636,    2},
};

STD_ROM_PICK(Megamn2a) STD_ROM_FN(Megamn2a)

struct BurnDriver BurnDrvCpsMegamn2a=
{
	{"megamn2a", "Mega Man 2: The Power Fighters (Asia 960708)", NULL, "Capcom", "CPS2", "1996", "megaman2", NULL},
	BDF_CLONE, 2, HARDWARE_CAPCOM_CPS2,
	NULL, Megamn2aRomInfo, Megamn2aRomName, DrvInputInfo, NULL,
	Cps2Init, CpsExit, Cps2Frame, CpsRedraw, CpsAreaScan,
	&CpsRecalcPal ,384, 224, 4, 3
};

/*=================
 Rockman 2 (Japan)
=================*/


static struct BurnRomInfo Rckman2jRomDesc[]=
{
	{"rm2jx.03"  , 0x080000, 0x2c297750, 0x10},
	{"rm2jx.04"  , 0x080000, 0x676a116e, 0x10},

	{"rm2j.03"   , 0x080000, 0xdbaa1437, 0x10},
	{"rm2j.04"   , 0x080000, 0xcf5ba612, 0x10},
	{"rm2.05"    , 0x080000, 0x02ee9efc, 0x10},

	{"rm2.14"    , 0x200000, 0x9b1f00b4,    1},
	{"rm2.16"    , 0x200000, 0xc2bb0c24,    1},
	{"rm2.18"    , 0x200000, 0x12257251,    1},
	{"rm2.20"    , 0x200000, 0xf9b6e786,    1},

	{"rm2.01a"   , 0x020000, 0xd18e7859,    2},
	{"rm2.02"    , 0x020000, 0xc463ece0,    2},

	{"rm2.11"    , 0x200000, 0x2106174d,    2},
	{"rm2.12"    , 0x200000, 0x546c1636,    2},
};

STD_ROM_PICK(Rckman2j) STD_ROM_FN(Rckman2j)

struct BurnDriver BurnDrvCpsRckman2j=
{
	{"rckman2j", "Rockman 2: The Power Fighters (Japan 960708)", NULL, "Capcom", "CPS2", "1996", "megaman2", NULL},
	BDF_GAME_WORKING | BDF_CLONE, 2, HARDWARE_CAPCOM_CPS2,
	NULL, Rckman2jRomInfo, Rckman2jRomName, DrvInputInfo, NULL,
	Cps2Init, CpsExit, Cps2Frame, CpsRedraw, CpsAreaScan,
	&CpsRecalcPal, 384, 224, 4, 3
};
