// Media module
#include "app.h"

int MediaInit()
{
	if (ScrnInit()) {					// Init the Scrn Window
		AppError("ScrnInit Failed",0);
		return 1;
	}

	DinpInit(hAppInst, hScrnWnd);		// Init DirectInput (can still use keyboard if it fails)
	InputInit();						// Init Input

	nAppVirtualFps = nBurnFPS;

	AudSoundInit();						// Init DSound (not critical if it fails)

	nBurnSoundRate = 0;					// Assume no sound
	pBurnSoundOut = NULL;
	if (bAudOkay) {
		nBurnSoundRate = nAudSampleRate;
		nBurnSoundLen = nAudSegLen;
	}

	return 0;
}

int MediaExit(bool bRestart)
{
	nBurnSoundRate = 0;					// Blank sound
	pBurnSoundOut = NULL;

	DestroyWindow(hInpsDlg);			// Make sure the Input Set dialog is exitted
	DestroyWindow(hInpdDlg);			// Make sure the Input Dialog is exitted

	VidExit();
	AudSoundExit();						// Exit Dsound
	InputExit();
	DinpExit();							// Exit DirectInput

	ScrnExit(bRestart);					// Exit the Scrn Window

	return 0;
}
