// Memory card support module

#include "app.h"

static char	szMemoryCardFile[MAX_PATH];

int nMemoryCardStatus = 0;
int nMemoryCardSize;

static int MakeOfn()
{
	memset(&ofn, 0, sizeof(ofn));
	ofn.lStructSize = sizeof(ofn);
	ofn.hwndOwner = hScrnWnd;
	ofn.lpstrFile = szMemoryCardFile;
	ofn.nMaxFile = sizeof(szMemoryCardFile);
	ofn.lpstrInitialDir = ".";
	ofn.Flags = OFN_NOCHANGEDIR | OFN_HIDEREADONLY;
	ofn.lpstrDefExt = "fc";
	
	return 0;
}

static int MemCardDoGetSize(struct BurnArea* pba)
{
	nMemoryCardSize = pba->nLen;
	
	return 0;
}

static int MemCardGetSize()
{
	BurnAcb = MemCardDoGetSize;
	BurnAreaScan(ACB_MEMCARD, NULL);

	return 0;
}

int	MemCardCreate()
{
	int nRet;

	sprintf (szMemoryCardFile, "memcard");
	MakeOfn();
	ofn.lpstrTitle = "Create new memory card";
	ofn.lpstrFilter = "FB Alpha Memory cards (*.fc)\0*.fc\0\0";
	ofn.Flags |= OFN_OVERWRITEPROMPT;

	int bOldPause = bRunPause;
	bRunPause = 1;
	nRet = GetSaveFileName(&ofn);
	bRunPause = bOldPause;

	if (nRet == 0) {
		return 1;
	}
	
	FILE* fp = fopen(szMemoryCardFile, "wb");
	if (fp == NULL) {
		return 1;
	} else {
		unsigned char* pCard;
		
		MemCardGetSize();
		
		pCard = (unsigned char*)malloc(nMemoryCardSize);
		memset(pCard, 0, nMemoryCardSize);
		
		fwrite(pCard, 1, nMemoryCardSize, fp);
		fclose(fp);

		free(pCard);
	}

	nMemoryCardStatus = 1;
	MenuEnableItems();

	return 0;
}

int	MemCardSelect()
{
	int nRet;

	sprintf (szMemoryCardFile, "memcard");
	MakeOfn();
	ofn.lpstrTitle = "Select memory card";
	ofn.lpstrFilter = "FB Alpha Memory cards (*.fc)\0*.fc\0MAME Memory cards (MEMCARD.\?\?\?)\0MEMCARD.\?\?\?\0\0";

	int bOldPause = bRunPause;
	bRunPause = 1;
	nRet = GetOpenFileName(&ofn);
	bRunPause = bOldPause;

	if (nRet == 0) {
		return 1;
	}

	MemCardGetSize();
	
	if (nMemoryCardSize <= 0) {
		return 1;
	}

	nMemoryCardStatus = 1;
	MenuEnableItems();

	return 0;
}

static int MemCardDoInsert(struct BurnArea* pba)
{
	FILE* fp = fopen(szMemoryCardFile, "rb");
	if (fp) {
		fread((unsigned char*)pba->Data, 1, pba->nLen, fp);
		fclose(fp);
		
		nMemoryCardStatus |= 2;
		MenuEnableItems();

		return 0;
	}

	return 1;
}

int	MemCardInsert()
{
	if ((nMemoryCardStatus & 1) && (nMemoryCardStatus & 2) == 0) {
		BurnAcb = MemCardDoInsert;
		BurnAreaScan(ACB_WRITE | ACB_MEMCARD, NULL);
	}
	
	return 0;
}

static int MemCardDoEject(struct BurnArea* pba)
{
	FILE* fp = fopen(szMemoryCardFile, "wb");
	if (fp) {
		fwrite((unsigned char*)pba->Data, 1, pba->nLen, fp);
		fclose(fp);
		
		nMemoryCardStatus &= ~2;
		MenuEnableItems();

		return 0;
	}

	return 1;
}

int	MemCardEject()
{
	if ((nMemoryCardStatus & 1) && (nMemoryCardStatus & 2)) {
		BurnAcb = MemCardDoEject;
		BurnAreaScan(ACB_READ | ACB_MEMCARD, NULL);
	}
	
	return 0;
}

