// Audio Output plugin
struct AudOut {
	int (*BlankSound)();
	int (*SoundCheck)();
	int (*SoundInit)();
	int (*SoundPlay)();
	int (*SoundStop)();
	int (*SoundExit)();
	int (*SoundSetVolume)();
};

int AudSoundInit();
int AudSoundExit();
int AudSoundPlay();
int AudSoundStop();
int AudBlankSound();
int AudSoundCheck();
int AudSoundSetVolume();

extern int nAudSampleRate;          // sample rate
extern int nAudSegCount;          	// Segs in the pdsbLoop buffer
extern int nAudSegLen;            	// Seg length in samples (calculated from Rate/Fps)
extern short *nAudNextSound;       	// The next sound seg we will add to the sample loop
extern unsigned char bAudOkay;    	// True if DSound was initted okay
extern unsigned char bAudPlaying;	// True if the Loop buffer is playing
extern int nAudDSPModule;			// DSP module to use: 0 = none, 1 = low-pass filter
extern long nDSoundVol;
extern int (*DSoundGetNextSound) (int bDraw); // Callback used to request more sound

// Video Output plugin:
struct VidOut {
  int (*Init)();
  int (*Exit)();
  int (*Frame)(bool bRedraw);
  int (*Paint)(int bValidate);
  int (*ImageSize)(RECT *pRect, int nGameWidth, int nGameHeight);
};

int VidSelect(unsigned int nPlugin);
int VidInit();
int VidExit();
int VidFrame();
int VidRedraw();
int VidRecalcPal();
int VidPaint(int bValidate);
int VidImageSize(RECT *pRect, int nGameWidth, int nGameHeight);

extern bool bVidOkay;
extern HWND hVidWnd;
extern unsigned int nVidSelect;
extern int nVidWidth, nVidHeight, nVidDepth, nVidRefresh;
extern int nVidFullscreen;
extern int bVidBilinear;
extern int bVidScanlines;
extern int bVidScanRotate;
extern int bVidScanBilinear;
extern int nVidScanIntensity;
extern int bVidScanHalf;
extern int bVidScanDelay;
extern int nVidFeedbackIntensity;
extern int nVidFeedbackOverSaturation;
extern int bVidCorrectAspect;
extern int bVidArcaderes;
extern int nVidRotationAdjust;
extern int bVidUseHardwareGamma;
extern int bVidForce16bit;
extern int nVidTransferMethod;
extern float fVidScreenAngle;
extern float fVidScreenCurvature;
extern int nVidBlitterOpt[];
extern int bVidFullStretch;
extern int bVidTripleBuffer;

extern int nVidScrnWidth, nVidScrnHeight;
extern int nVidScrnDepth;

extern int nVidScrnAspectX, nVidScrnAspectY;

extern unsigned char* pVidImage;
extern int nVidImageWidth, nVidImageHeight;
extern int nVidImageLeft, nVidImageTop;
extern int nVidImagePitch, nVidImageBPP;
extern int nVidImageDepth;

extern "C" unsigned int (*VidHighCol) (int r, int g, int b, int i);

extern bool bVidUsePlaceholder;
extern char szPlaceHolder[MAX_PATH];

// vid_directx_support.cpp
int VidSNewShortMsg(const char* pText, int nRGB = 0, int nDuration = 0, int nPiority = 5);
void VidSKillShortMsg();

int VidSAddChatMsg(const char* pID, int nIDRGB, const char* pMain, int nMainRGB);

extern int nVidSDisplayStatus;
extern int nMaxChatFontSize;
extern int nMinChatFontSize;
extern bool bEditActive;
extern bool bEditTextChanged;
extern char EditText[64];


